function dm = ldfm_frq2dim (F) 

% dm = ldfm_frq2dim (F)
%
% computes the dimensionality of explicit feature map 
%  construced using all frequencies in F
%
% For more details see Chum: Low Dimensional Explicit Feature Maps, ICCV'15
% http://cmp.felk.cvut.cz/~chum
% (C) Ondrej Chum 2015

  dm = F;
  dm(dm ~= 0) = 2;
  dm(dm == 0) = 1;
  dm = prod(dm,1);