clear X
steps = 128;

X.d{1}.x = [0:steps-1] / (steps-1) *  log(512); % discretized first input dimension
X.d{1}.max_delta = 0.1;  % maximal frequency delta for continuos optimization for 1st dimension

f = inline('sech(x/2)', 'x'); % kernel signature to approximate for chi-square
%f = inline('exp(-abs(x)/2)', 'x'); %kernel signature to approximate for intersection
%f= inline('exp(x/2).*log2(1+exp(-x))/2+exp(-x/2).*log2(1+exp(x))/2','x'); %kernel signature to approximate for JS

% Select absolute / relative error to be optimized
% observe the difference in kernel signature fit error plot

X.eps_multiplier = exp(X.d{1}.x / 2); %use this to minimize l_infty
%X.eps_multiplier = f(X.d{1}.x); % use this to minimize the relative error


F = [0:X.d{1}.max_delta:10]; % frequency pool

[nF, w, Y] = ldfm_kernelsignature(X, f, F, 7); % approximate with 15 dimensional feature map

x = [0:10:512];
o = homog1d_embed(nF,w,x);

V = reshape(o' * o, length(x), length(x));

figure(1); clf; hold on
surface(x,x,V);
title('Approximate kernel surface');

figure(2); clf; hold on
k = ker1d_embed(nF,w,Y.domain); % get the feature map for full domain
plot(Y.domain, Y.values,'-');
plot(Y.domain, k(:,1)'*k,'-r'); % plot Psi(0)' * Psi(x)
title('Kernel signature fit');

figure(3); clf; hold on
plot(Y.domain, Y.values - k(:,1)'*k,'-');
title('Error plot of kernel signature fit');